#!/usr/bin/python3

from charmhelpers.core import hookenv
from charmhelpers.core.services import helpers
from charmhelpers.core.services.base import ServiceManager

import actions


class MongoRelation(helpers.RelationContext):

    name = 'mongodb'
    interface = 'mongodb'


def manage():
    config = hookenv.config()
    manager = ServiceManager([
        {
            'service': 'result-enum-api',
            'provided_data': [actions.WebsiteRelation()],
            'required_data': [config, MongoRelation()],
            'data_ready': [
                actions.basenode,
                actions.install_packages,
                actions.get_cloud_service_from_tarball,
                actions.install_python_packages,
                actions.get_config_file,
                actions.prepare_for_wsgi,
                helpers.render_template(
                    source='upstart.conf',
                    target='/etc/init/result-enum-api.conf'),
                actions.publish_website_relation_data,
                actions.log_start,
            ],
        },
    ])
    manager.manage()
